from ply import yacc
from lexer import tokens

root_dict = dict()

def p_toml(p):
    "toml : content"


def p_content_multi(p):
    "content : content tomlEntries"


def p_content_single(p):
    "content : tomlEntries"
       

def p_tomlEntries_table(p):
    "tomlEntries : table"
      

def p_tomlEntries_object(p):
    "tomlEntries : object"
       

def p_table_simple(p):
    "table : '[' ID ']'"
    headers = p[2].split(".")
    temp_dict = {}
    for header in headers[::-1]:
        temp_dict = {header : temp_dict}
    p[0] = temp_dict


# isto ta errado 
def p_table_array(p):
    "table : '[' '[' ID ']' ']'"
    headers = p[3].split(".")
    entry = []
    temp_dict = {}
    for header in headers[::-1]:
        temp_dict = {header : entry}
     
    res = temp_dict
    p[0] = res


def p_object_value(p):
    "object : key '=' value"
    headers = p[1]
    temp_dict = {headers[headers.length-1] : p[3]} 
    for header in headers[::-1].pop():
        temp_dict = {header : temp_dict}
    return temp_dict


def p_object_array(p):
    "object : key '=' array"
     

def p_object_dict(p):
    "object : key '=' dict"


def p_array_cont(p):
    "array : '[' aCont ']'"


def p_array_empty(p):
    "array : '[' ']'"


def p_aCont_multiple(p):
    "aCont : aCont ',' aElem"


def p_aCont_single(p):
    "aCont : aElem"


def p_aElem_value(p):
    "aElem : value"


def p_aElem_dict(p):
    "aElem : dict"


def p_aElem_array(p):
    "aElem : array"


def p_dict_cont(p):
    "dict : '{' dictCont '}'"


def p_dict_empty(p):
    "dict : '{' '}'"


def p_dictCont_multiple(p):
    "dictCont : dictCont ',' dictElem"


def p_dictCont_single(p):
    "dictCont : dictElem"


def p_dictElem_object(p):
    "dictElem : object"


def p_key_id(p):
    "key : ID"


def p_key_str(p):
    "key : STR"


def p_key_float(p):
    "key : FLOAT"


def p_key_int(p):
    "key : INT"
    

def p_value_str(p):
    "value : STR"
    p[0] = p[1]


def p_value_mlstr(p):
    "value : MLSTR"
    p[0] = p[1]

def p_value_date(p):
    "value : DATE"
    p[0] = p[1]

def p_value_datetime(p):
    "value : DATETIME"
    p[0] = p[1]


def p_value_int(p):
    "value : INT"
    p[0] = int(p[1])

def p_value_float(p):
    "value : FLOAT"
    p[0] = float(p[1])


def p_value_hex(p):
    "value : HEX"
    p[0] = hex(p[1])

def p_value_bin(p):
    "value : BIN"
    p[0] = bin(p[1])


def p_value_oct(p):
    "value : OCT"
    p[0] = oct(p[1])

def p_value_inf(p):
    "value : INF"
    p[0] = float(p[1])

def p_value_nan(p):
    "value : NAN"
    p[0] = p[1]


parser = yacc.yacc()
